package net.cattaka.rdbassistant.gui.config;

import java.awt.Frame;
import java.awt.HeadlessException;

import javax.swing.JDialog;

import net.cattaka.rdbassistant.config.RdbaConfig;
import net.cattaka.util.MessageBundle;

public class RdbaConfigEditorDialog extends JDialog {
	private static final long serialVersionUID = 1L;
	private boolean approvalFlag = false;
	public RdbaConfigEditorPanel rdbaConfigEditorPanel;
	
	public RdbaConfigEditorDialog(Frame owner) throws HeadlessException {
		super(owner);
		this.setSize(600,400);
		this.setTitle(MessageBundle.getMessage("config"));
		this.makeLayout();
	}
	
	private void makeLayout() {
		this.rdbaConfigEditorPanel = new RdbaConfigEditorPanel() {
			private static final long serialVersionUID = 1L;
			@Override
			public void doApprove() {
				approvalFlag = true;
				RdbaConfigEditorDialog.this.setVisible(false);
			}
			@Override
			public void doCancel() {
				approvalFlag = false;
				RdbaConfigEditorDialog.this.setVisible(false);
			}
		};
		this.getContentPane().add(rdbaConfigEditorPanel);
	}
	
	public void loadRdbaConfig(RdbaConfig rdbaConfig) {
		rdbaConfigEditorPanel.loadRdbaConfig(rdbaConfig);
	}

	public void saveRdbaConfig(RdbaConfig rdbaConfig) {
		rdbaConfigEditorPanel.saveRdbaConfig(rdbaConfig);
	}

	public boolean showEditor() {
		this.approvalFlag = false;
		this.setModal(true);
		this.setVisible(true);
		return this.approvalFlag;
	}
}
