package net.cattaka.rdbassistant.jspf.core;

import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import net.cattaka.rdbassistant.jspf.core.bean.DatabaseInfo;

public class RdbaJspfBundle {
	private List<String> jspfList;
	private HashMap<String, JspfBase> jspfBaseMap;
	
	public RdbaJspfBundle() {
		this.jspfList = new ArrayList<String>();
		this.jspfBaseMap = new HashMap<String, JspfBase>();
	}
	
	public JspfBase[] getJspfList() {
		JspfBase[] result = new JspfBase[this.jspfList.size()];
		for (int i=0;i<result.length;i++) {
			result[i] = jspfBaseMap.get(this.jspfList.get(i));
		}
		return result;
	}
	
	public void runJspfBundle(String name, JspfSelectionInfo selectionInfo, DatabaseInfo databaseInfo, PrintWriter out)
		throws SQLException, JspfNotFoundException, JspfMessageException
	{
		JspfBase jspfBase = this.get(name);
		if (jspfBase == null) {
			throw new JspfNotFoundException("JSPF : "+name+" is not found.");
		}
		jspfBase.setDatabaseInfo(databaseInfo);
		jspfBase.setSelectionInfo(selectionInfo);
		jspfBase.runJspf(out);
	}

	public JspfBase put(String key, JspfBase value) {
		JspfBase jspfBase = jspfBaseMap.put(key, value);
		if (!this.jspfList.contains(key)) {
			this.jspfList.add(key);
		}
		return jspfBase;
	}

	public JspfBase remove(Object key) {
		jspfList.remove(key);
		return jspfBaseMap.remove(key);
	}

	public JspfBase get(String name) {
		return jspfBaseMap.get(name);
	}
	
}
